from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Int

Dcm2Pnm_V0_1_0 = CommandToolBuilder(tool="dcm2pnm", base_command=["dcm2pnm"], inputs=[ToolInput(tag="in_arguments", input_type=Boolean(optional=True), prefix="--arguments", doc=InputDocumentation(doc="print expanded command line arguments")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="quiet mode, print no warnings and errors")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="verbose mode, print processing details")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="debug mode, print debug information")), ToolInput(tag="in_log_level", input_type=Boolean(optional=True), prefix="--log-level", doc=InputDocumentation(doc="[l]evel: string constant\n(fatal, error, warn, info, debug, trace)\nuse level l for the logger")), ToolInput(tag="in_log_config", input_type=Boolean(optional=True), prefix="--log-config", doc=InputDocumentation(doc="[f]ilename: string\nuse config file f for the logger")), ToolInput(tag="in_read_dataset", input_type=Boolean(optional=True), prefix="--read-dataset", doc=InputDocumentation(doc="read data set without file meta information")), ToolInput(tag="in__readxferauto_use", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="=   --read-xfer-auto      use TS recognition (default)")), ToolInput(tag="in_read_xfer_detect", input_type=Boolean(optional=True), prefix="--read-xfer-detect", doc=InputDocumentation(doc="ignore TS specified in the file meta header")), ToolInput(tag="in_read_xfer_little", input_type=Boolean(optional=True), prefix="--read-xfer-little", doc=InputDocumentation(doc="read with explicit VR little endian TS")), ToolInput(tag="in_read_xfer_big", input_type=Boolean(optional=True), prefix="--read-xfer-big", doc=InputDocumentation(doc="read with explicit VR big endian TS")), ToolInput(tag="in_read_xfer_implicit", input_type=Boolean(optional=True), prefix="--read-xfer-implicit", doc=InputDocumentation(doc="read with implicit VR little endian TS")), ToolInput(tag="in_ignore_aspect", input_type=Boolean(optional=True), prefix="--ignore-aspect", doc=InputDocumentation(doc="ignore pixel aspect ratio when scaling")), ToolInput(tag="in_no_interpolation", input_type=Boolean(optional=True), prefix="--no-interpolation", doc=InputDocumentation(doc="no interpolation when scaling")), ToolInput(tag="in_no_scaling", input_type=Boolean(optional=True), prefix="--no-scaling", doc=InputDocumentation(doc="no scaling, ignore pixel aspect ratio (default)")), ToolInput(tag="in_no_modality", input_type=Boolean(optional=True), prefix="--no-modality", doc=InputDocumentation(doc="ignore stored modality LUT transformation")), ToolInput(tag="in_no_windowing", input_type=Boolean(optional=True), prefix="--no-windowing", doc=InputDocumentation(doc="no VOI windowing (default)")), ToolInput(tag="in_no_overlays", input_type=Boolean(optional=True), prefix="--no-overlays", doc=InputDocumentation(doc="do not display overlays")), ToolInput(tag="in_no_interlace", input_type=Boolean(optional=True), prefix="--nointerlace", doc=InputDocumentation(doc="create non-interlaced file")), ToolInput(tag="in_meta_none", input_type=Boolean(optional=True), prefix="--meta-none", doc=InputDocumentation(doc="no PNG file meta information")), ToolInput(tag="in_image_info", input_type=Boolean(optional=True), prefix="--image-info", doc=InputDocumentation(doc="print image details (requires verbose mode)")), ToolInput(tag="in_no_output", input_type=Boolean(optional=True), prefix="--no-output", doc=InputDocumentation(doc="do not create any output (useful with -im)")), ToolInput(tag="in_dcm_file_in", input_type=String(), position=0, doc=InputDocumentation(doc="DICOM input filename to be converted")), ToolInput(tag="in_bitmap_out", input_type=String(), position=1, doc=InputDocumentation(doc="output filename to be written (default: stdout)")), ToolInput(tag="in_integer", input_type=Int(), position=0, doc=InputDocumentation(doc="use interpolation when scaling (1..4, def: 1)")), ToolInput(tag="in_interpretation", input_type=String(), position=0, doc=InputDocumentation(doc="+Mp   --accept-palettes     accept incorrect palette attribute tags"))], outputs=[], container="quay.io/biocontainers/dcmtk:3.6.5--h5fca97b_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Dcm2Pnm_V0_1_0().translate("wdl")

